CCTimerOptionsEffectHeader = class(Turbine.UI.Control);

function CCTimerOptionsEffectHeader:Constructor(parent, w, h, labels)
	Turbine.UI.Control.Constructor(self);

	self.parent = parent;
	self.h = h;
	self.w = w;

	self.name = Turbine.UI.Label();
	self.name:SetPosition(h + 5, 0);
	self.name:SetHeight(h);
	self.name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.name:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.name:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.name:SetText("Name");
	self.name:SetParent(self);

	self.fields = { };
	for _, label in ipairs(labels) do
		local field = Turbine.UI.Label();
		field:SetSize(w, h);
		field:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		field:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		field:SetFontStyle(Turbine.UI.FontStyle.Outline);
		field:SetText(label);
		field:SetParent(self);
		table.insert(self.fields, field);
	end

	self:SetHeight(h);
	self:SetParent(parent);
end

function CCTimerOptionsEffectHeader:SizeChanged()
	local w = self:GetWidth();
	local w1 = math.max(self.w, w - (self.h + #self.fields * (self.w + 5) + 10));

	self.name:SetWidth(w1);

	local x = self.h + w1 + 5;
	for _, field in ipairs(self.fields) do
		field:SetPosition(x, 0);
		x = x + self.w + 5;
	end
end
