CCTimerOptionsLabeledField = class(Turbine.UI.Control);

local function fnFocusGained(self, args)
	self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.value = self:GetText();
end

local function fnFocusLost(self, args)
	self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self:SetText(self.value);
	self.value = nil;
end
local function fnKeyDown(self, args)
	if args.Action == 162 then
		local x = self.parent.outgoing(self:GetText());

		if x ~= false then
			self.parent.parent:SetSetting(self.parent.root, self.parent.shortcut, self.parent.entry, x);
			self.parent:SetValue(x);
		end

		self.parent:Focus();
	end
end

function CCTimerOptionsLabeledField:Constructor(parent, w1, w2, w3, h, preLabel, postLabel, root, shortcut, entry, outgoing, incoming)
	Turbine.UI.Control.Constructor(self);

	self.parent = parent;
	self.root = root;
	self.shortcut = shortcut;
	self.entry = entry;
	self.outgoing = outgoing;
	self.incoming = incoming;

	self:SetParent(parent);
	self:SetSize(w1 + w2 + w3, h);

	if preLabel ~= nil then
		self.preLabel = Turbine.UI.Label();
		self.preLabel:SetSize(w1, h);
		self.preLabel:SetPosition(0, 0);
		self.preLabel:SetParent(self);
		self.preLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		self.preLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		self.preLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
		self.preLabel:SetText(preLabel);
	end

	self.field = Turbine.UI.Lotro.TextBox();
	self.field.parent = self;
	self.field:SetSize(w2, h);
	self.field:SetPosition(w1, 0);
	self.field:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	self.field:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.field.FocusGained = fnFocusGained;
	self.field.FocusLost = fnFocusLost;
	self.field.KeyDown = fnKeyDown;
	self.field:SetParent(self);

	if postLabel ~= nil then
		self.postLabel = Turbine.UI.Label();
		self.postLabel:SetSize(w3, h);
		self.postLabel:SetPosition(w1 + w2, 0);
		self.postLabel:SetParent(self);
		self.postLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		self.postLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		self.postLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
		self.postLabel:SetText(postLabel);
	end
end

function CCTimerOptionsLabeledField:SetValue(value)
	value = self.incoming(value);
	if self.field.value ~= nil then
		self.field.value = value;
	end
	self.field:SetText(value);
end