import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

function layout(items)
	local lanes = { };

	for i, item in ipairs(items) do
		if item.top == nil or item.bottom == nil then
			lanes[i] = false;
		else
			item.overlaps = { };
		end
	end

	local lane = 0;
	for i = 1, #items, 1 do
		if lanes[i] == nil then
			lane = lane + 1;
			local overlap = { };
			for j = i, #items, 1 do
				if lanes[j] == nil and overlap[j] == nil then
					lanes[j] = lane;
					for k = j + 1, #items, 1 do
						if items[j].bottom <= items[k].top and items[k].bottom <= items[j].top then
							overlap[k] = true;
							table.insert(items[k].overlaps, j);
						end
					end
				end
			end
		end
	end

	for i, item in ipairs(items) do
		if lanes[i] then
			item.lane = lanes[i];
		else
			item.lane = nil;
		end
	end

	return lane;
end